<template>
  <div v-if="type == 'lines'" class="main-item">
    <div class="main-item main-item__block">
      <div class="main-item__top">
        <div class="main-item__left">
          <div class="main-item__title" v-html="title"></div>
          <div class="main-item__description" v-html="content"></div>
          <div class="main-item__link">
            <div
              v-for="link in links"
              :key="link.title"
              :class="`main-item__link ${link.class}`"
            >
              <nuxt-link :to="link.to">
                {{ link.title }}
              </nuxt-link>
            </div>
          </div>
        </div>
        <div class="main-item__right">
          <div
            v-for="icon in icons"
            :key="icon.icon"
            :class="`main-item__icon ${icon.class}`"
          >
            <svg-icon :name="icon.icon" />
          </div>
        </div>
      </div>
      <div class="hide-mobile">
        <div class="main-item__gallery">
          <div v-for="(item, index) in images" :key="index" :class="item.class">
            <img :src="item.src" />
          </div>
        </div>
      </div>
      <template>
        <client-only>
          <CoolLightBox
            :items="images"
            :index="index"
            @close="index = null"
          ></CoolLightBox>
          <swiper
            class="main-item__slider hide-desktop"
            :options="swiperMainOptions"
          >
            <swiper-slide v-for="(item, itemIndex) in images" :key="itemIndex">
              <img @click="index = itemIndex" :src="item.src" />
            </swiper-slide>
            <div class="swiper-pagination" slot="pagination"></div>
          </swiper>
        </client-only>
      </template>
    </div>
  </div>
  <div v-else class="main-item">
    <div class="main-item__left">
      <div class="main-item__title" v-html="title"></div>
      <div class="main-item__description" v-html="content"></div>
      <div
        v-for="link in links"
        :key="link.title"
        :class="`main-item__link ${link.class}`"
      >
        <nuxt-link :to="link.to">
          {{ link.title }}
        </nuxt-link>
      </div>
      <div
        v-for="icon in icons"
        :key="icon.icon"
        :class="`main-item__icon ${icon.class}`"
      >
        <svg-icon :name="icon.icon" />
      </div>
    </div>
    <div class="main-item__right">
      <div class="hide-mobile">
        <div class="main-item__gallery">
          <div v-for="(item, index) in images" :key="index" :class="item.class">
            <img :src="item.src" />
          </div>
        </div>
      </div>
      <template>
        <client-only>
          <CoolLightBox
            :items="images"
            :index="index"
            @close="index = null"
          ></CoolLightBox>
          <swiper
            class="main-item__slider hide-desktop"
            :options="swiperMainOptions"
          >
            <swiper-slide v-for="(item, itemIndex) in images" :key="itemIndex">
              <img @click="index = itemIndex" :src="item.src" />
            </swiper-slide>
            <div class="swiper-pagination" slot="pagination"></div>
          </swiper>
        </client-only>
      </template>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'

import { Swiper, SwiperSlide, directive } from 'vue-awesome-swiper'
import 'swiper/css/swiper.css'

// @ts-ignore TODO
import CoolLightBox from 'vue-cool-lightbox'
import '@/assets/scss/vue-cool-lightbox.scss'

export default defineComponent<{
  type: String[]
  title: String[]
  content: String[]
  icons: Array<String>
  links: Array<String>
  images: Array<String>
}>({
  name: 'MainItem',
  components: {
    CoolLightBox,
    Swiper,
    SwiperSlide
  },
  directives: {
    swiper: directive
  },
  props: ['type', 'title', 'content', 'icons', 'links', 'images'],
  data() {
    return {
      index: null,
      swiperMainOptions: {
        autoHeight: true,
        slidesPerView: 1,
        spaceBetween: 30,
        loop: true,
        pagination: {
          el: '.swiper-pagination',
          clickable: true
        }
      }
    }
  }
})
</script>

<style lang="scss" scoped>
.main-item {
  display: flex;
  flex-direction: column;
  margin-bottom: 60px;
  text-align: center;

  $self: &;
  &:last-child {
    margin-bottom: 0;
  }

  @media (min-width: 1199.98px) {
    flex-direction: row;
    margin-bottom: 160px;
    text-align: left;
    &:last-child {
      margin-bottom: 0;
    }
  }

  &__left {
    flex: none;
    order: 2;
    display: flex;
    flex-direction: column;
    @media (min-width: 1199.98px) {
      max-width: 400px;
      margin-right: 100px;
      order: 1;
      display: block;
    }
  }

  &__right {
    flex: 1;
    order: 1;
    margin-bottom: 45px;
    img {
      max-width: 100%;
    }
    @media (min-width: 1199.98px) {
      order: 2;
      margin-bottom: 0px;
      img {
        max-width: 100%;
      }
    }
  }

  &__block {
    #{ $self }_right {
      margin-bottom: 0px;
    }

    #{ $self }_top {
      order: 2;
    }
    .main-item__slider,
    #{ $self }_gallery {
      order: 1;
      margin-bottom: 45px;
    }
    #{ $self }_link {
      margin-bottom: 0;
    }

    @media (min-width: 1199.98px) {
      display: block;
      #{ $self }__left {
        max-width: 70%;
      }

      #{ $self }__description {
        margin-bottom: 30px;
      }

      #{ $self }__link {
        margin-bottom: 0;
      }

      #{ $self }__icon {
        flex: 1;
        svg {
          margin: 0 0 0 auto;
        }
      }

      #{ $self }__gallery {
        margin-bottom: 0px;
      }
    }
  }

  &__top {
    display: flex;
    flex-direction: column;
    order: 2;
    @media (min-width: 1199.98px) {
      order: 1;
      align-items: flex-end;
      flex-direction: row;
      margin-bottom: 140px;
    }
  }

  &__title {
    color: #ffffff;
    font-size: 40px;
    line-height: 45px;
    letter-spacing: -1px;
    margin-bottom: 10px;
    order: 2;
    @media (min-width: 1199.98px) {
      font-size: 45px;
      line-height: 45px;
      letter-spacing: -1.13px;
      margin-top: 10px;
      margin-bottom: 25px;
    }
  }

  &__description {
    color: #9badd6;
    font-size: 24px;
    line-height: 33px;
    order: 3;
    @media (min-width: 1199.98px) {
      font-size: 30px;
      line-height: 36px;
      margin-bottom: 50px;
    }
    ::v-deep p {
      margin-bottom: 25px;
      margin-top: 0px;
      @media (min-width: 1199.98px) {
        margin-bottom: 35px;
      }
      &:last-child {
        margin-bottom: 0;
      }
    }
  }

  &__link {
    text-align: center;
    font-size: 30px;
    line-height: 38px;
    font-weight: 500;
    letter-spacing: 0px;
    color: #5799ff;
    margin-top: 30px;
    order: 4;
    a {
      color: inherit;
      text-decoration: none;
      background-image: linear-gradient(
        0deg,
        currentColor 100%,
        rgba(32, 126, 150, 0)
      );
      background-size: 0 1px;
      padding-bottom: 2px;
      background-position: 200% 100%;
      background-repeat: no-repeat;
      transform-origin: left bottom;
      transition: background-size 0.5s ease,
        background-position 0.6s ease-out 0.1s, color 0.5s ease;
      &:hover {
        background-size: 100% 1px;
        background-position: 0 100%;
        animation: underline-hover forwards;
        animation-duration: 0.3s;
      }
    }

    @media (min-width: 1199.98px) {
      text-align: left;
      font-size: 30px;
      line-height: 38px;
      margin-bottom: 60px;
      margin-top: 0px;
    }

    &.style {
      &-1 {
        color: #e61b98;
      }
    }
  }

  &__icon {
    order: 1;
    margin-bottom: 25px;
    svg {
      width: 65px;
      height: 65px;
      margin: 0 auto;
      display: block;
    }

    &.style {
      &-1 {
        svg {
          fill: #0065ff;
        }
      }

      &-3 {
        svg {
          fill: #00ffb3;
        }
      }

      &-4 {
        svg {
          fill: #e61b98;
        }
      }
    }

    @media (min-width: 1199.98px) {
      margin-bottom: 0px;
      svg {
        width: 100px;
        height: 100px;
        margin: 0px;
      }

      &.style {
        &-1 {
          svg {
            width: 120px;
            height: 120px;
          }
        }

        &-2 {
          svg {
            width: 90px;
            height: 90px;
          }
        }

        &-3 {
          svg {
            width: 90px;
            height: 90px;
          }
        }

        &-4 {
          svg {
            width: 95px;
            height: 95px;
          }
        }
      }
    }
  }

  &__gallery {
    display: flex;
    > * {
      max-width: 50%;
      margin-right: 30px;

      &:last-child {
        margin-right: 0;
      }
    }
    @media (min-width: 1199.98px) {
      .style {
        &-1 {
          transform: translateY(-120px);
          margin-bottom: -120px;
        }

        &-2 {
          transform: translateY(-50px);
          margin-bottom: -50px;
        }

        &-3 {
          transform: translateY(-30px);
          margin-bottom: -30px;
        }

        &-4 {
          transform: translateY(50px);
          margin-bottom: 50px;
        }

        &-5 {
          transform: translateY(200px);
          margin-bottom: 200px;
        }
      }
    }
  }

  &__slider {
    font-size: 0px;
    max-width: 100%;
    img {
      max-height: 400px;
      display: block;
      margin: 0 auto;
    }

    ::v-deep {
      .swiper-pagination {
        margin-top: 25px;
        position: relative;
        bottom: inherit;
        &-bullet {
          width: 10px;
          height: 10px;
          background: #7683ad;
          opacity: 1;
          &-active {
            background: #fff;
          }
        }
      }
    }
  }
}

@media (min-width: 1199.98px) {
  .main-item {
    $self: &;

    &__revers {
      flex-direction: row-reverse;
      #{ $self }__left {
        margin-left: 100px;
        margin-right: 0;
      }
    }
  }
}
</style>
